/* issue3328.c	-- Dominic Lavoie Wed Jul 09 2008
 *
 * $Log$
 */

#include <Python.h>


// export PYTHONPHOME=.
// export PYTHONPATH='.;../Lib'
int main(int argc, char* argv[])
{
  PyObject* pName;
  PyObject* pModule;
  PyObject* pFunc;
  PyObject* pObj;
  PyObject* pFuncRv;

  // Py_SetProgramName("issue3328.exe");

  Py_Initialize();

  printf("Python sys.path = %s\n", Py_GetPath());

  pName = PyString_FromString("issue3328");
  pModule = PyImport_Import(pName);
  Py_DECREF(pName);

  if (pModule == NULL) {
    PyErr_Print();
    return -1;
  }

  pFunc = PyObject_GetAttrString(pModule, "Issue3328");
  if (pFunc == NULL) {
    PyErr_Print();
    return -1;
  }

  pObj = PyObject_CallObject(pFunc, 0);
  if (pObj == NULL) {
    PyErr_Print();
    return -1;
  }

  printf("pObj->ob_refcnt=%d\n", pObj->ob_refcnt);
  pFuncRv = PyObject_CallMethod(pObj, "f", 0);
  printf("pObj->ob_refcnt=%d\n", pObj->ob_refcnt);
  if (pFuncRv == 0) {
    PyErr_Print();
    return -1;
  }

  Py_Finalize();

  return 0;
}
